
//////////////////// PRIVATE //////////////////////

//
// private merge
// 
template<typename T>
typename list<T>::listNode* list<T>::merge(listNode * a, listNode * b){
  
  listNode dummy; 
  listNode * head = &dummy, * c = head;
  while ( (a != 0) && (b != 0) ) // scan the two list
    if (a->item_ < b->item_)     // a is the min
      { c->next_ = a; c = a; a = a->next_;}// move a to nxt
    else
      { c->next_ = b; c = b; b = b->next_;}// move b to nxt
  c->next_ = (a==0) ? b : a; // a is ended, then link b
  
  //
  std::cerr << "\t Merged on ";
  listNode * tmp = head->next_;
  while (tmp){
    std::cerr << " " << tmp->item_;
    tmp = tmp->next_;
  }
  std::cerr << std::endl;
  
  //
  return head->next_;
};

//
// private mergesort
//
template<typename T>
typename list<T>::listNode* list<T>::mergesort(listNode* c){
    
   if (c==0 || c->next_ == 0) return c;
   
   //
   std::cerr << "Calling mergesort on ";
   listNode * tmp = c;
   while (tmp){
     std::cerr << " " << tmp->item_;
     tmp = tmp->next_;
   }
   std::cerr << std::endl;
   //
   
   // a points to the first, b to the next one
   link a = c, b = c->next_;
   
   // there are at least 3
   while ((b != 0) && (b->next_ != 0))
     { c = c->next_; b = b->next_->next_; }
   // exiting the above while c will point
   // to the half point of list
   
   b = c->next_; // this is the next pos in list
   c->next_ = 0; // terminate the list after half point
   
   return merge(mergesort(a), mergesort(b));
 };

//////////////////// PUBLIC //////////////////////

//
// empty list
//
template <typename T>
bool list<T>::empty() const {return (head_->next_==0); };

//
// destructor
//
template <typename T>
list<T>::~list(){   
  
  link tmp = head_->next_; // take first one
  
  while (tmp){                   // is there something
    
    head_->next_ = tmp->next_;   // get the next one
    delete tmp;                  // delete current
    tmp = head_->next_;          // go to the next one
  }

  tail_ = head_;
}

//
// insert a node
//
template <typename T>
void list<T>::insertNode(const T &element)
{
  link tmp = new listNode(element);  // create new node
  tmp->next_ = 0;                    //   no one after so far
  tail_->next_ = tmp;                //   insert it end of list
  tail_ = tmp;                       // move the tail  
};

//
// delete a node
//
template <typename T>
bool list<T>::deleteNode(const T &element){

  link tmp, previous;
  bool returnValue = false;
  
  for (tmp = head_->next_, previous = head_; 
       tmp!=0; 
       tmp=tmp->next_, previous = previous->next_ ){
    
      if (tmp->item_ == element){
	
	previous->next_=tmp->next_;
	delete tmp;
	returnValue = true;
	break;
      }
  }
  return returnValue;
};

//
// sort the list
//
template <typename T>
void list<T>::sort() 
{
  head_ = mergesort(head_->next_);
}


